#
# pre-load module for IWMC's wwwd
#

def search(keyword,cond = 'and',title='',writer='',number='')
		hits = []

		return <<EOT if keyword == '' and title=='' and writer=='' and number==''
Content-type: text/plain

sȌłB
EOT

		keys = keyword.split(' ')
		for mes in $messageDB.messages
			flag = true
			flag = mes.hit?(keys,cond) if keyword != ''
			flag = mes.title =~ title if flag
			flag = mes.writer =~ writer if flag

			if number != '' and flag then
				flag = (mes.number == number.to_i)
			end
			hits << mes if flag
		end
#-------------------------------
		if $messageDB.loading? then
			loadingMsg = "#{$messageDB.lastIndex.to_s} loaded.<BR>\n"
		else
			loadingMsg = ""
		end
output = <<EOT
Content-type: text/html

<HTML>
<HEAD>
</HEAD>
<BODY>
#{loadingMsg}#{hits.size} Y <BR>
L[[h:#{keyword} <BR>
薼:#{title}<BR>
e:#{writer}<BR>
EOT
		text = <<EOF
#{hits.size} hit(s).
keyword:#{keyword}
EOF
#-------------------------------
		for mes in hits
#-------------------------------
			output += <<EOT
<HR>
No.:#{mes.number}  (#{mes.major}-#{mes.minor})<BR>
薼:#{mes.title}<BR>
e:#{mes.writer}<BR>
eeF#{mes.parent}<P>
#{mes.content}

EOT
#-------------------------------
		end
#-------------------------------
		output +=  <<EOT
</BODY>
</HTML>
EOT
#-------------------------------
	return output
end


def process
	queries = ENV["POST_TEXT"].split('&')
	query={}
	for text in queries
	    text.gsub!(/\+/n, ' ')
		text.gsub!(/%([0-9a-fA-F]{2})/n){ [$1.hex].pack("c")}
		text =~ /([^=]+)\=(.*)/
		query[$1]=$2
	end
	output = search(query['keyword'],query['andor'],query['title'],query['writer'],query['number'])

	return output
end

#ENV["POST_TEXT"] = "keyword=e&andor=and&title=&writer="
#process
